/*
 * Copyright 2016-2021 Amazon.com, Inc. or its affiliates. All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You may not use this file except in compliance with
 * the License. A copy of the License is located at
 * 
 * http://aws.amazon.com/apache2.0
 * 
 * or in the "license" file accompanying this file. This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions
 * and limitations under the License.
 */
package com.amazonaws.services.gluedatabrew.model;

import java.io.Serializable;
import javax.annotation.Generated;
import com.amazonaws.protocol.StructuredPojo;
import com.amazonaws.protocol.ProtocolMarshaller;

/**
 * <p>
 * Options that define the structure of Csv job output.
 * </p>
 * 
 * @see <a href="http://docs.aws.amazon.com/goto/WebAPI/databrew-2017-07-25/OutputFormatOptions" target="_top">AWS API
 *      Documentation</a>
 */
@Generated("com.amazonaws:aws-java-sdk-code-generator")
public class OutputFormatOptions implements Serializable, Cloneable, StructuredPojo {

    /**
     * <p>
     * Options that define how DataBrew writes Csv output.
     * </p>
     */
    private CsvOutputOptions csv;

    /**
     * <p>
     * Options that define how DataBrew writes Csv output.
     * </p>
     * 
     * @param csv
     *        Options that define how DataBrew writes Csv output.
     */

    public void setCsv(CsvOutputOptions csv) {
        this.csv = csv;
    }

    /**
     * <p>
     * Options that define how DataBrew writes Csv output.
     * </p>
     * 
     * @return Options that define how DataBrew writes Csv output.
     */

    public CsvOutputOptions getCsv() {
        return this.csv;
    }

    /**
     * <p>
     * Options that define how DataBrew writes Csv output.
     * </p>
     * 
     * @param csv
     *        Options that define how DataBrew writes Csv output.
     * @return Returns a reference to this object so that method calls can be chained together.
     */

    public OutputFormatOptions withCsv(CsvOutputOptions csv) {
        setCsv(csv);
        return this;
    }

    /**
     * Returns a string representation of this object. This is useful for testing and debugging. Sensitive data will be
     * redacted from this string using a placeholder value.
     *
     * @return A string representation of this object.
     *
     * @see java.lang.Object#toString()
     */
    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("{");
        if (getCsv() != null)
            sb.append("Csv: ").append(getCsv());
        sb.append("}");
        return sb.toString();
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;

        if (obj instanceof OutputFormatOptions == false)
            return false;
        OutputFormatOptions other = (OutputFormatOptions) obj;
        if (other.getCsv() == null ^ this.getCsv() == null)
            return false;
        if (other.getCsv() != null && other.getCsv().equals(this.getCsv()) == false)
            return false;
        return true;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int hashCode = 1;

        hashCode = prime * hashCode + ((getCsv() == null) ? 0 : getCsv().hashCode());
        return hashCode;
    }

    @Override
    public OutputFormatOptions clone() {
        try {
            return (OutputFormatOptions) super.clone();
        } catch (CloneNotSupportedException e) {
            throw new IllegalStateException("Got a CloneNotSupportedException from Object.clone() " + "even though we're Cloneable!", e);
        }
    }

    @com.amazonaws.annotation.SdkInternalApi
    @Override
    public void marshall(ProtocolMarshaller protocolMarshaller) {
        com.amazonaws.services.gluedatabrew.model.transform.OutputFormatOptionsMarshaller.getInstance().marshall(this, protocolMarshaller);
    }
}
